<?php

Class Build_Tree extends ComVironment_Outputs
{
	// Public
	
	var $step = -1; //
	var $length = 0; //
	var $height = 0; //
	var $hlevOpen = 0;
	var $cmhs = array();
	var $levbut = array();
	var $ingre = array();
	var $button = array();
	var $tree = array();
	var $icon = array();
	var $last = array();
	var $fileArray = array();
	var $mayDel = array();
	var $nohllink = "";
	
	var $bDir;
	var $dirs_are;
	var $stors_are;
	var $ground_max = 0;
	var $cfg_ed;
	var $cfg_aded;
	var $cfg_noed;
	var $editMode;
	var $virtue_access_group;
	var $virtue_seminars_admin_array;
	var $virtue_admin_sites;
	
	
	function Build_Tree()
	{
		global $dirs_are, $stors_are, $cfg_aded, $cfg_ed;
		global $cfg_noed, $virtue_access_group;
		global $virtue_seminars_admin_array, $virtue_admin_sites;
		
		$this -> dirs_are = $dirs_are;
		$this -> stors_are = $stors_are;
		$this -> cfg_ed = $cfg_ed;
		$this -> cfg_aded = $cfg_aded;
		$this -> cfg_noed = $cfg_noed;
		$this -> virtue_access_group = $virtue_access_group;
		$this -> virtue_seminars_admin_array = $virtue_seminars_admin_array;
		$this -> virtue_admin_sites = $virtue_admin_sites;
	}
	
	function btInit($ft,$hlevOpenToSet=0,$nl,$tl)
	{
		$this -> bDir = $ft . "/";
		$this -> hlevOpen = $hlevOpenToSet;
		$this -> nohllink = $nl;
		$this -> tasklink = $tl;
		$this -> editMode = substr($ft,0,strpos ($ft, "/"));
	}
	
	function build($buildLevel=0, $step=-1)
	{
		$buildNav = $this -> _getCmsnav($buildLevel);
		//$this -> step = $step;
		foreach ($buildNav as $x => $w) {
			if($this -> _showThat($w[0],$w[2],$buildLevel))
			{
				$this -> step++;
				// build path/to/file
				$sdir = implode("/",array_slice($this -> cmhs,0,$buildLevel)); 
				if($sdir != "") $sdir .= "/";
				
				$iconCl = !empty($w[6]) ? "_" . $w[6] : "";
				
				$this -> tree[$this -> step][$buildLevel+1]  = 
					$this -> cvIcon($this -> cfg_ed[$w[2]][1],$iconCl) . " " . $w[1];
	
				$this -> ingre[$this -> step][0]  = $w[0]; // the filename
				$this -> ingre[$this -> step][1]  = $w[1]; // the visible name
				$this -> ingre[$this -> step][2]  = $w[2] ? $w[2] : "o"; // the type
				$this -> ingre[$this -> step][3]  = $w[3]; // the hierarchical access
				$this -> ingre[$this -> step][4]  = $buildLevel; // this site's column
				$this -> ingre[$this -> step][5]  = $sdir; // the path
				$this -> ingre[$this -> step][6]  = $x;    // the number in the currDir
				$this -> ingre[$this -> step][7]  = $w[4]; // group access
				$this -> ingre[$this -> step][8]  = $w[5]; // virsem access
				$this -> ingre[$this -> step][9]  = $w[6]; // the site's color
				$this -> ingre[$this -> step][10] = $w[7]; // semester
				$this -> last[$buildLevel] = $this -> step;
	
				if($buildLevel==0) {
					$this -> levbut[$x]=$w[1];
				}
				
				if (in_array($w[2],$this -> dirs_are)) {
					$this -> cmhs[$buildLevel]=$w[0];
	
					if( $buildLevel > 0 || 
						($this -> hlevOpen != "" && $this -> hlevOpen == $x) || 
						 $this -> hlevOpen == -1) {
						$this -> build($buildLevel+1,$this -> step);
					} else {
						$this -> may_del[$step] = 
							sizeof($this -> _getCmsnav($buildLevel+1));
					}
				} else {
					$this -> length = max($buildLevel+1,$this -> length);
				}
			}
		}
	}
	
	function produceButtons()
	{
		global $tr;
		
		/* Define the absolute height of the complete tree */ 
		$this -> ground_max = sizeof($this -> ingre);
		
		/* If just the groundlevel is shown, give hlevOpen a number that
			is not used in the whole tree: It's absolute height. We need a number */
		if($this -> hlevOpen=="") $this -> hlevOpen = $this -> ground_max;
		
		/* define the height of the tree open */
		$this -> height = sizeof($this -> tree);
		
		for($i=0;$i<$this -> height;$i++,$dont_del=1,$do_o2d=1)
		{
			// Produce Edit-Buttons
			if	(
				$this -> _canBeEdit(
					$this -> ingre[$i][4], $this -> ingre[$i][6], $this -> ground_max)
				) {
				
				if(in_array($this -> ingre[$i][2],$this -> stors_are)) {
					$get_array = array(
						"base" => $this -> ingre[$i][5] . $this -> ingre[$i][0] . "/",
						"ftyp" => $this -> ingre[$i][2],
						"hacc" => $this -> ingre[$i][3],
						"gacc" => $this -> ingre[$i][7],
						"vacc" => $this -> ingre[$i][8],
						"dfil" => $this -> ingre[$i][0],
						"dcms" => $this -> ingre[$i][5],
						"dnum" => $this -> ingre[$i][6]
					);
				}

				if(!in_array($this -> ingre[$i][2], $this -> dirs_are)) {
					if($this -> _mayEdit($this -> ingre[$i][2])) {
						$this -> button[$i]["edit"]  = 
							$this -> cvButton(
								4,$this -> ingre[$i][2],
								$tr["Edit"],"submit_green"
							);
						
						if($this -> ingre[$i][2]=="o") {
							$this -> button[$i]["html"]  = 
								$this -> cvButton(
									9,$this -> ingre[$i][2],
									$tr["EditCode"],"submit_grey"
								);
						}
					}
	
					if($this -> ingre[$i][6] > 0 || 
					   $this -> ingre[$i][4] == $this -> ingre[$i+1][4]) 
					{
						if($this -> ingre[$i][6] == 0 && $this -> ingre[$i+1][8] == 1)
							$dont_del = 1;
						else
							$dont_del = 0;
					} else {
						$dont_del = 1;
					}
	
					if(!sizeof($this -> fileArray))
						$do_o2d = 0;
	
				} else {
					$this -> fileArray = array();
					$this -> fileArray = $this -> _getFileArray(
						$this -> ingre[$i][5] . $this -> ingre[$i][0]
					);

					if(
						($this -> ingre[$i+2][4]!= ($this -> ingre[$i][4] +1) ||
						 !$this -> ingre[$i+2][4])) {
						$dont_del = 0;
					} // Sucht alle leeren Verzeichnisse und Grundlevels
					if(in_array($this -> ingre[$i+1][2],$this -> dirs_are)) {
						$dont_del = 1;
					} //Wenn leer, kann auch ein Verzeichnis drin sein 
					if($this -> ingre[$i][4] == 0 && $this -> hlevOpen != -1 ) {
						$dont_del = 1;
					} // In anderer als der Komplettansicht 
					  //darf nicht gelscht werden 
					if($this -> ingre[$i][4] == 0 && 
						$this -> may_del[$this -> ingre[$i][6]] == 1) {
						$dont_del = 0;
					}
					if($this -> ingre[$i][4] == 0 && $this -> ingre[$i][6] == 0) {
						$dont_del = 1;
					} // Das allererste: Nie
					if($this -> ingre[$i][2] == "v") {
						$dont_del = 1;
					} // Virtuelle Seminare: Nie
	
					if(sizeof($this -> fileArray)) {
						$do_o2d = 0;	
					}
				}
				
				if(!$dont_del) {
					if(!in_array($this -> ingre[$i][2],$this -> stors_are)) {
						$this -> button[$i]["del"] =  
							$this -> cvButton(
								5,$this -> ingre[$i][2],
								$tr["Delete"],"submit_red"
							);
					} else {
						$this -> button[$i]["del"]  = "<a href=\"" . 
							$this -> tasklink . "&acar=" .
							base64_encode(serialize($get_array)) . 
							"\" class=\"submit_red\">" . 
							"<span style=\"color:#000000\">" . $tr["Delete"] . 
							"</span></a>";
					}
				}
				if($this -> ingre[$i][6]) {
					if($this -> ingre[$i][6]==1 && $this -> ingre[$i][8]==1);
					else if($this -> ingre[$i][4] == 0 && 
							$this -> hlevOpen > -1 &&
							$this -> hlevOpen < $this -> ground_max && 
							$this -> ingre[$i][2] != 'o');
					else if($this -> ingre[$i][2]!="v") {
						$this -> button[$i]["up"] =  
							$this -> cvButton(
								6,$this -> ingre[$i][2],
								$tr["Up"],"submit_yellow"
							);
					} 
				}
				
				if(	$this -> ingre[$i][2]== "v" && 
					$this -> hlevOpen == $this -> ground_max) {
					$this -> button[$i]["edit"]  = "<a href=\"" . 
						$this -> nohllink . "&hlev_open=" .
						$this -> ingre[$i][6] . "\" class=\"submit_green\">" . 
						"<span style=\"color:#000000\">" . $tr["VirSemEdit"] . 
						"</span></a>";
				} else if(in_array($this -> ingre[$i][2],$this -> stors_are)) {
					$this -> button[$i]["edit"]  = "<a href=\"" . 
						$this -> tasklink . "&acar=" .
						base64_encode(serialize($get_array)) . 
						"\" class=\"submit_green\">" . 
						"<span style=\"color:#000000\">" . $tr["Edit"] . 
						"</span></a>";
				}
	
				if(	$this -> editMode == "cms" &&
					$this -> ingre[$i][4] == 0 && 
					$this -> hlevOpen > -1 && 
					$this -> hlevOpen < $this -> ground_max);
				else
				{
					$this -> button[$i]["data"] =  
							$this -> cvButton(
								3,$this -> ingre[$i][2],
								$tr["Data"],"submit_blue"
							);
	
					if($this -> ingre[$i][2]!="v")
					{
						$this -> button[$i]["new"] =  
							$this -> cvButton(
								2,$this -> ingre[$i][2],
								$tr["New"],"submit_turq"
							);
					}
				}
			}
			$this -> icon[$i] = $this -> ingre[$i][4] + 1;
		}
	}

	function produceTree()
	{
		for ($j=0; $j<=$this -> length;$j++) {
			$new_begin = 1;
	
			for($i=$this -> height-1;$i>=0;$i--) {
				if(!$this -> tree[$i][$j]) {
					if($this -> tree[$i][$j+1]) {
						if($new_begin) {
							$new_begin = 0;
							$this -> tree[$i][$j] = $this -> cvIcon("ell");
						} else {
							$this -> tree[$i][$j] = $this -> cvIcon("tee");
						}
					} else {
						if($new_begin) {
							$this -> tree[$i][$j] = $this -> cvIcon("ooo");
						} else {
							$this -> tree[$i][$j] = $this -> cvIcon("iii");
						}
					}
				} else {
					$new_begin = 1;
				}
			}
		}
	}
	
	function produceLevelButtons($ad_index, $acl)
	{
		global $tr;
		$bl_size = sizeof($this -> levbut) + 2;
		if($bl_size > 5) 
		{	
			$bl_lines = (int)($bl_size/5);
			if($bl_size % 5 != 0) $bl_lines++;
			$bl_columns = (int)($bl_size/$bl_lines);
			$bl_backlog = $bl_size%$bl_lines;
			for($b=0; $b+1<$bl_lines; $b++)
			{
				$bl_break[$b] = ($b+1) * $bl_columns;
				if($bl_backlog > $b)$bl_break[$b] += $b+1;
			}
		}
		
		$i=0;
	
		echo "<table border=\"0\" width=\"100%\" ";
		echo "cellpadding=\"5\" cellspacing=\"0\">\n";
		echo "<tr bgcolor=\"$acl\"><td>";
		
		echo "\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		echo "<tr>";
	
		echo "<td align=\"middle\">\n";
		echo "<form action=\"" . $this -> nohllink . "\" method=\"post\">\n";
		echo "<input type=\"submit\" value=\"" . $tr["BasicLevel"] . "\" ";
		echo "class=\"submit";
		echo  $this -> hlevOpen == $this -> ground_max ? "_grey" : "_white";
		echo "\" ";
		echo "style=\"width:150px\">\n";
		echo "</form></td>\n";
	
		echo "<td align=\"middle\">\n";
		echo "<form action=\"" . $this -> nohllink . "\" method=\"post\">\n";
		echo "<input type=\"hidden\" name=\"hlev_open\" value=\"-1\">\n";
		echo "<input type=\"submit\" value=\"" . $tr["Complete"] . "\" ";
		echo "class=\"submit";
		echo  $this -> hlevOpen == -1 ? "_grey" : "_white";
		echo "\" ";
		echo "style=\"width:150px\">\n";
		echo "</form></td>\n";
	
		if(sizeof($this -> levbut))
		{
			foreach($this -> levbut as $x => $w)
			{
				if(sizeof($bl_break) && in_array(($i+++2),$bl_break))
				{
					echo "</tr></table>\n<table border=\"0\" cellpadding=\"0\" ";
					echo " cellspacing=\"0\"><tr>";
				}
				if(($b_length = strlen($w))>22)
				{
					$w[0] = substr($w, 0, 19) . "...";
				}
				echo "<td align=\"middle\">\n";
				echo "<form action=\"" . $this -> nohllink . "\" method=\"post\">\n";
				echo "<input type=\"hidden\" name=\"hlev_open\" value=\"$x\">\n";
				echo "<input type=\"submit\" value=\"$w\" class=\"submit";
				echo $this -> hlevOpen == $x ? "_grey" : "_white";
				echo "\" style=\"width:150px\">\n";
				echo "</form>\n</td>\n";
			}
		}
		
		$get_array = array(
			"base" => "",
		);
		
		echo "<td align=\"middle\">\n";
		echo "<form action=\"$ad_index\" method=\"post\">\n";
		echo "<input type=\"hidden\" name=\"function\" value=\"edit_popup\">\n";
		echo "<input type=\"hidden\" name=\"acar\"";
		echo "value=\"" . base64_encode(serialize($get_array)) . "\">\n";
		echo "<input type=\"submit\" value=\"" . $tr["Popups"] . "\" ";
		echo "class=\"submit_white\" ";
		echo "style=\"width:150px\">\n";
		echo "</form></td>\n";
		echo "</tr></table>\n\n";

		echo "</td></tr>";
		echo "</table>\n";
	}
	
	function produceInstruction($j)
	{
		return array (
			"path" => $this -> ingre[$j][5],
			"file" => $this -> ingre[$j][0],
			"name" => $this -> ingre[$j][1],
			"type" => $this -> ingre[$j][2],
			"hacc" => $this -> ingre[$j][3],
			"gacc" => $this -> ingre[$j][7],
			"vacc" => $this -> ingre[$j][8],
			"hlev" => $this -> ingre[$j][4],
			"dnum" => $this -> ingre[$j][6],
			"colo" => $this -> ingre[$j][9],
			"ssem" => $this -> ingre[$j][10]
		);
	}
	
	function startTr($cl1, $cl2, $cl3, $id) {
		echo "<tr style=\"background-color:$cl1;\" height=\"20\" id=\"$id\" ";
		echo "onmouseover=\"if(!cl$id){this.style.backgroundColor='$cl2';}\" ";
		echo "onmouseout=\"if(!cl$id){this.style.backgroundColor='$cl1';}\" ";
		echo "onmousedown=\"if(!cl$id){cl$id=1;this.style.backgroundColor='$cl3';}";
		echo "else{cl$id=0;this.style.backgroundColor='$cl1';}\" ";
		echo "valign=\"middle\">\n<td><nobr>";
	}
	
	function showButtons($j)
	{
		echo "<td width=\"16\">";
		echo "<img src=\"" . $this -> _imgDir . "ooo.gif\" ";
		echo "width=\"16\" height=\"20\">";
		echo "</td>\n";
		
		echo "<td width=\"90\" align=\"center\">";
		if($this -> button[$j]["data"])	echo $this -> button[$j]["data"];
		else							echo "&nbsp;";
		echo "</td>\n";
		
		echo "<td width=\"90\" align=\"center\">";
		if($this -> button[$j]["new"])	echo $this -> button[$j]["new"];
		else							echo "&nbsp;";
		echo "</td>\n";
		
		echo "<td width=\"90\" align=\"center\">";
		if($this -> button[$j]["up"])	echo $this -> button[$j]["up"];
		else							echo "&nbsp;";
		echo "</td>\n";
		
		echo "<td width=\"90\" align=\"center\">";
		if($this -> button[$j]["edit"])	echo $this -> button[$j]["edit"];
		else							echo "&nbsp;";
		echo "</td>\n";
		
		echo "<td width=\"90\" align=\"center\">";
		if($this -> button[$j]["html"])	echo $this -> button[$j]["html"];
		else							echo "&nbsp;";
		echo "</td>\n";
		
		echo "<td width=\"90\" align=\"center\">";
		if($this -> button[$j]["del"])	echo $this -> button[$j]["del"];
		else							echo "&nbsp;";
		echo "</td>\n";
		
		echo "<td width=\"16\">";
		echo "<img src=\"" . $this -> _imgDir . "ooo.gif\" ";
		echo "width=\"16\" height=\"20\">";
		echo "</td>\n";
	}
	
	function showMouseJava()
	{
		echo "\n<script type=\"text/javascript\" language=\"javascript\">\n";
		for ($i=0; $i<$this -> ground_max; $i++) {
			echo "\tvar cl$i = 0;\n";
		}
		echo "</script>\n\n";
	}

	function startForm($selflink,$j)
	{
		echo "<form action=\"$selflink\" method=\"post\">\n";
		echo "<input type=\"hidden\" name=\"inst\" value=\"";
		echo base64_encode(serialize($this -> produceInstruction($j)));
		echo "\">\n";
		echo "<input type=\"hidden\" name=\"hlev_open\" ";
		echo "value=\"" . $this -> hlevOpen . "\">\n";
	}
	function startTable($body_bgcolor)
	{
		echo "<table bgcolor=\"$body_bgcolor\" width=\"100%\" ";
		echo "border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n";
	}
	function _getCmsnav($buildLevel=0)
	{
		$hs_cdir = $this -> _contentDir . $this -> bDir;
		$hs_cdir.= $buildLevel ? 
			implode("/",array_slice($this -> cmhs,0,$buildLevel)) . "/" :
			"";
		$content_file = $hs_cdir . "content.name";
		
		if(file_exists($content_file)) {
			$c = fopen($content_file, "r");
			if($c) {
				for($i=0;!feof($c);$i++) {
					$line = trim(fgets($c, 4096));
					if($line!="") {
						$cmsnav[]=explode(":", $line);
					}
				}
			} else {
				$this -> _cmsError(123);
			}
		} else {
			$this -> _cmsError(122);
		}
		return $cmsnav;
	}
	
	function _showThat($name, $typ, $buildLevel=0)
	{
		if( $buildLevel==0 && 
			$this -> virtue_access_group==5 && 
			$this -> editMode == "cms") {
			if($typ=="d" && $this -> virtue_admin_sites) {
				$igg=1;
			} else if	(
							$typ=="v" && 
							in_array($name,$this -> virtue_seminars_admin_array)
						) {
				$igg=1;
			} else {
				$igg=0;
			}
		} else {
			$igg = 1;
		}
		return $igg;
	}
	
	function _mayEdit($typ)
	{
		if(in_array($typ, $this -> cfg_noed)) return 0;
		else if (in_array($typ, $this -> cfg_aded) && 
			$this -> virtue_access_group < 6) return 0;
		else return 1;
	}
	
	function _canBeEdit($i, $j, $k)
	{	// $i: this site's column
		// $j: the number in the currDir
		// $k: the absolute height of the complete tree
		if(		$this -> editMode != "cms" ||
				$i != 0 ||
				$j == $this -> hlevOpen || 
				$this -> hlevOpen == $k ||
				$this -> hlevOpen == -1
		) {
			return 1;
		} else {
			return 0;
		}

	}
	
	function _getFileArray($fto)
	{
		$handle = opendir($this -> _contentDir . $this -> bDir . $fto);
		while ($file = readdir ($handle)) {
			if ($file != "." &&
				$file != ".." &&
				$file != "content.name" &&
				$file != "index.txt" &&
				$file != "index.php")
			{
				$file_array[] = $file;
			}
		}
		closedir($handle);
		return $file_array;
	}
	
	function _cmsError($errnum)
	{
		global $tr, $noback, $func_dir, $ext;
	
		$emsg = "<b>" . $tr["ErrorNo"] . " $errnum</b><br>";
		switch ($errnum)
		{
			case 122:
			case 123:
				$emsg.= $tr["CMSFileNotOpen"] . "<br>\n";
				$emsg.= "(";
				$emsg.= implode("/",$this -> cmhs) . "/_CMSFILE";
				$emsg.= ")<br><br>\n";
				break;
		}
		$emsg.= $tr["GiveNoticeAdmin"];
		$noback=1;
		include $func_dir . 'basic/errormessage' . $ext;
	}
}

?>
